<?php
/**
 *  Copyright 2014 Taxamo, Ltd.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/**
 * $model.description$
 *
 * NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
 *
 */
class Evidence {

  static $swaggerTypes = array(
      'by_2003_rules' => 'evidence_schema',
      'by_payment_method' => 'evidence_schema',
      'by_tax_number' => 'evidence_schema',
      'self_declaration' => 'evidence_schema',
      'by_cc' => 'evidence_schema',
      'by_ip' => 'evidence_schema',
      'by_token' => 'evidence_schema',
      'by_billing' => 'evidence_schema',
      'guessed_from_ip' => 'evidence_schema',
      'other_commercially_relevant_info' => 'evidence_schema',
      'forced' => 'evidence_schema'

    );

  /**
  * Used when merchant uses 2003 EU VAT rules.
  */
  public $by_2003_rules; // evidence_schema
  /**
  * Country detected by payment method.
  */
  public $by_payment_method; // evidence_schema
  /**
  * Country detected from EU TAX number
  */
  public $by_tax_number; // evidence_schema
  /**
  * Self declared country as evidence. Requires merchant setting to be active.
  */
  public $self_declaration; // evidence_schema
  /**
  * Country detected by credit card number prefix
  */
  public $by_cc; // evidence_schema
  /**
  * Country detected by IP
  */
  public $by_ip; // evidence_schema
  /**
  * Country detected from SMS token
  */
  public $by_token; // evidence_schema
  /**
  * Country detected by billing country code
  */
  public $by_billing; // evidence_schema
  /**
  * Country guessed from IP due to lack of other evidence
  */
  public $guessed_from_ip; // evidence_schema
  /**
  * Additional evidence held by the merchant. Can be used only with a private token.
  */
  public $other_commercially_relevant_info; // evidence_schema
  /**
  * Country forced by paramters
  */
  public $forced; // evidence_schema
  }

